
_Reset_PID:

;PID_Lib.mpas,59 :: 		begin
;PID_Lib.mpas,62 :: 		PID_Integrated := 0.0;
	MOVLW       12
	ADDWF       FARG_Reset_PID_Controller+0, 0 
	MOVWF       FSR1L 
	MOVLW       0
	ADDWFC      FARG_Reset_PID_Controller+1, 0 
	MOVWF       FSR1H 
	CLRF        POSTINC1+0 
	CLRF        POSTINC1+0 
	CLRF        POSTINC1+0 
	CLRF        POSTINC1+0 
;PID_Lib.mpas,63 :: 		PID_Prev_Input := 0.0;
	MOVLW       16
	ADDWF       FARG_Reset_PID_Controller+0, 0 
	MOVWF       FSR1L 
	MOVLW       0
	ADDWFC      FARG_Reset_PID_Controller+1, 0 
	MOVWF       FSR1H 
	CLRF        POSTINC1+0 
	CLRF        POSTINC1+0 
	CLRF        POSTINC1+0 
	CLRF        POSTINC1+0 
;PID_Lib.mpas,64 :: 		PID_First_Time := true;
	MOVLW       28
	ADDWF       FARG_Reset_PID_Controller+0, 0 
	MOVWF       FSR1L 
	MOVLW       0
	ADDWFC      FARG_Reset_PID_Controller+1, 0 
	MOVWF       FSR1H 
	MOVLW       255
	MOVWF       POSTINC1+0 
;PID_Lib.mpas,66 :: 		end;
L_end_Reset_PID:
	RETURN      0
; end of _Reset_PID

_Set_PID_Int_Improvement:

;PID_Lib.mpas,69 :: 		begin
;PID_Lib.mpas,70 :: 		Controller.PID_Int_Improvement := On_;
	MOVLW       29
	ADDWF       FARG_Set_PID_Int_Improvement_Controller+0, 0 
	MOVWF       FSR1L 
	MOVLW       0
	ADDWFC      FARG_Set_PID_Int_Improvement_Controller+1, 0 
	MOVWF       FSR1H 
	MOVF        FARG_Set_PID_Int_Improvement_On_+0, 0 
	MOVWF       POSTINC1+0 
;PID_Lib.mpas,71 :: 		end;
L_end_Set_PID_Int_Improvement:
	RETURN      0
; end of _Set_PID_Int_Improvement

_Init_PID:

;PID_Lib.mpas,74 :: 		begin
;PID_Lib.mpas,77 :: 		PID_Kp              := Kp;
	MOVFF       FARG_Init_PID_Controller+0, FSR1L
	MOVFF       FARG_Init_PID_Controller+1, FSR1H
	MOVF        FARG_Init_PID_Kp+0, 0 
	MOVWF       POSTINC1+0 
	MOVF        FARG_Init_PID_Kp+1, 0 
	MOVWF       POSTINC1+0 
	MOVF        FARG_Init_PID_Kp+2, 0 
	MOVWF       POSTINC1+0 
	MOVF        FARG_Init_PID_Kp+3, 0 
	MOVWF       POSTINC1+0 
;PID_Lib.mpas,78 :: 		PID_Ki              := Ki;
	MOVLW       4
	ADDWF       FARG_Init_PID_Controller+0, 0 
	MOVWF       FSR1L 
	MOVLW       0
	ADDWFC      FARG_Init_PID_Controller+1, 0 
	MOVWF       FSR1H 
	MOVF        FARG_Init_PID_Ki+0, 0 
	MOVWF       POSTINC1+0 
	MOVF        FARG_Init_PID_Ki+1, 0 
	MOVWF       POSTINC1+0 
	MOVF        FARG_Init_PID_Ki+2, 0 
	MOVWF       POSTINC1+0 
	MOVF        FARG_Init_PID_Ki+3, 0 
	MOVWF       POSTINC1+0 
;PID_Lib.mpas,79 :: 		PID_Kd              := Kd;
	MOVLW       8
	ADDWF       FARG_Init_PID_Controller+0, 0 
	MOVWF       FSR1L 
	MOVLW       0
	ADDWFC      FARG_Init_PID_Controller+1, 0 
	MOVWF       FSR1H 
	MOVF        FARG_Init_PID_Kd+0, 0 
	MOVWF       POSTINC1+0 
	MOVF        FARG_Init_PID_Kd+1, 0 
	MOVWF       POSTINC1+0 
	MOVF        FARG_Init_PID_Kd+2, 0 
	MOVWF       POSTINC1+0 
	MOVF        FARG_Init_PID_Kd+3, 0 
	MOVWF       POSTINC1+0 
;PID_Lib.mpas,80 :: 		PID_MinOutput       := MinOutput;
	MOVLW       20
	ADDWF       FARG_Init_PID_Controller+0, 0 
	MOVWF       FSR1L 
	MOVLW       0
	ADDWFC      FARG_Init_PID_Controller+1, 0 
	MOVWF       FSR1H 
	MOVF        FARG_Init_PID_MinOutput+0, 0 
	MOVWF       POSTINC1+0 
	MOVF        FARG_Init_PID_MinOutput+1, 0 
	MOVWF       POSTINC1+0 
	MOVF        FARG_Init_PID_MinOutput+2, 0 
	MOVWF       POSTINC1+0 
	MOVF        FARG_Init_PID_MinOutput+3, 0 
	MOVWF       POSTINC1+0 
;PID_Lib.mpas,81 :: 		PID_MaxOutput       := MaxOutput;
	MOVLW       24
	ADDWF       FARG_Init_PID_Controller+0, 0 
	MOVWF       FSR1L 
	MOVLW       0
	ADDWFC      FARG_Init_PID_Controller+1, 0 
	MOVWF       FSR1H 
	MOVF        FARG_Init_PID_MaxOutput+0, 0 
	MOVWF       POSTINC1+0 
	MOVF        FARG_Init_PID_MaxOutput+1, 0 
	MOVWF       POSTINC1+0 
	MOVF        FARG_Init_PID_MaxOutput+2, 0 
	MOVWF       POSTINC1+0 
	MOVF        FARG_Init_PID_MaxOutput+3, 0 
	MOVWF       POSTINC1+0 
;PID_Lib.mpas,82 :: 		PID_Integrated      := 0.0;
	MOVLW       12
	ADDWF       FARG_Init_PID_Controller+0, 0 
	MOVWF       FSR1L 
	MOVLW       0
	ADDWFC      FARG_Init_PID_Controller+1, 0 
	MOVWF       FSR1H 
	CLRF        POSTINC1+0 
	CLRF        POSTINC1+0 
	CLRF        POSTINC1+0 
	CLRF        POSTINC1+0 
;PID_Lib.mpas,83 :: 		PID_Prev_Input      := 0.0;
	MOVLW       16
	ADDWF       FARG_Init_PID_Controller+0, 0 
	MOVWF       FSR1L 
	MOVLW       0
	ADDWFC      FARG_Init_PID_Controller+1, 0 
	MOVWF       FSR1H 
	CLRF        POSTINC1+0 
	CLRF        POSTINC1+0 
	CLRF        POSTINC1+0 
	CLRF        POSTINC1+0 
;PID_Lib.mpas,84 :: 		PID_Int_Improvement := false;
	MOVLW       29
	ADDWF       FARG_Init_PID_Controller+0, 0 
	MOVWF       FSR1L 
	MOVLW       0
	ADDWFC      FARG_Init_PID_Controller+1, 0 
	MOVWF       FSR1H 
	CLRF        POSTINC1+0 
;PID_Lib.mpas,85 :: 		PID_First_Time      := true;
	MOVLW       28
	ADDWF       FARG_Init_PID_Controller+0, 0 
	MOVWF       FSR1L 
	MOVLW       0
	ADDWFC      FARG_Init_PID_Controller+1, 0 
	MOVWF       FSR1H 
	MOVLW       255
	MOVWF       POSTINC1+0 
;PID_Lib.mpas,87 :: 		end;
L_end_Init_PID:
	RETURN      0
; end of _Init_PID

PID_Lib_Sign:

;PID_Lib.mpas,90 :: 		begin
;PID_Lib.mpas,91 :: 		Result := 0;                     // negative
	CLRF        Sign_local_result+0 
;PID_Lib.mpas,92 :: 		if Value >= 0 then Result := 1;  // positive
	CLRF        R4 
	CLRF        R5 
	CLRF        R6 
	CLRF        R7 
	MOVF        FARG_Sign_Value+0, 0 
	MOVWF       R0 
	MOVF        FARG_Sign_Value+1, 0 
	MOVWF       R1 
	MOVF        FARG_Sign_Value+2, 0 
	MOVWF       R2 
	MOVF        FARG_Sign_Value+3, 0 
	MOVWF       R3 
	CALL        _Compare_Double+0, 0
	MOVLW       0
	BTFSC       STATUS+0, 0 
	MOVLW       255
	MOVWF       R0 
	MOVF        R0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L_PID_Lib_Sign5
	MOVLW       1
	MOVWF       Sign_local_result+0 
L_PID_Lib_Sign5:
;PID_Lib.mpas,93 :: 		end;
	MOVF        Sign_local_result+0, 0 
	MOVWF       R0 
L_end_Sign:
	RETURN      0
; end of PID_Lib_Sign

PID_Lib_Limit:

;PID_Lib.mpas,96 :: 		begin
;PID_Lib.mpas,97 :: 		if Value < MinOutput
	MOVFF       FARG_Limit_Value+0, FSR0L
	MOVFF       FARG_Limit_Value+1, FSR0H
	MOVF        POSTINC0+0, 0 
	MOVWF       R0 
	MOVF        POSTINC0+0, 0 
	MOVWF       R1 
	MOVF        POSTINC0+0, 0 
	MOVWF       R2 
	MOVF        POSTINC0+0, 0 
	MOVWF       R3 
	MOVF        FARG_Limit_MinOutput+0, 0 
	MOVWF       R4 
	MOVF        FARG_Limit_MinOutput+1, 0 
	MOVWF       R5 
	MOVF        FARG_Limit_MinOutput+2, 0 
	MOVWF       R6 
	MOVF        FARG_Limit_MinOutput+3, 0 
	MOVWF       R7 
	CALL        _Compare_Double+0, 0
	MOVLW       255
	BTFSC       STATUS+0, 0 
	MOVLW       0
	MOVWF       R0 
	MOVF        R0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L_PID_Lib_Limit9
;PID_Lib.mpas,98 :: 		then Value := MinOutput
	MOVFF       FARG_Limit_Value+0, FSR1L
	MOVFF       FARG_Limit_Value+1, FSR1H
	MOVF        FARG_Limit_MinOutput+0, 0 
	MOVWF       POSTINC1+0 
	MOVF        FARG_Limit_MinOutput+1, 0 
	MOVWF       POSTINC1+0 
	MOVF        FARG_Limit_MinOutput+2, 0 
	MOVWF       POSTINC1+0 
	MOVF        FARG_Limit_MinOutput+3, 0 
	MOVWF       POSTINC1+0 
	GOTO        L_PID_Lib_Limit10
;PID_Lib.mpas,99 :: 		else if Value > MaxOutput then Value := MaxOutput;
L_PID_Lib_Limit9:
	MOVFF       FARG_Limit_Value+0, FSR0L
	MOVFF       FARG_Limit_Value+1, FSR0H
	MOVF        POSTINC0+0, 0 
	MOVWF       R0 
	MOVF        POSTINC0+0, 0 
	MOVWF       R1 
	MOVF        POSTINC0+0, 0 
	MOVWF       R2 
	MOVF        POSTINC0+0, 0 
	MOVWF       R3 
	MOVF        R0, 0 
	MOVWF       R4 
	MOVF        R1, 0 
	MOVWF       R5 
	MOVF        R2, 0 
	MOVWF       R6 
	MOVF        R3, 0 
	MOVWF       R7 
	MOVF        FARG_Limit_MaxOutput+0, 0 
	MOVWF       R0 
	MOVF        FARG_Limit_MaxOutput+1, 0 
	MOVWF       R1 
	MOVF        FARG_Limit_MaxOutput+2, 0 
	MOVWF       R2 
	MOVF        FARG_Limit_MaxOutput+3, 0 
	MOVWF       R3 
	CALL        _Compare_Double+0, 0
	MOVLW       255
	BTFSC       STATUS+0, 0 
	MOVLW       0
	MOVWF       R0 
	MOVF        R0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L_PID_Lib_Limit12
	MOVFF       FARG_Limit_Value+0, FSR1L
	MOVFF       FARG_Limit_Value+1, FSR1H
	MOVF        FARG_Limit_MaxOutput+0, 0 
	MOVWF       POSTINC1+0 
	MOVF        FARG_Limit_MaxOutput+1, 0 
	MOVWF       POSTINC1+0 
	MOVF        FARG_Limit_MaxOutput+2, 0 
	MOVWF       POSTINC1+0 
	MOVF        FARG_Limit_MaxOutput+3, 0 
	MOVWF       POSTINC1+0 
L_PID_Lib_Limit12:
L_PID_Lib_Limit10:
;PID_Lib.mpas,100 :: 		end;
L_end_Limit:
	RETURN      0
; end of PID_Lib_Limit

_PID_Calculate:

;PID_Lib.mpas,104 :: 		begin
;PID_Lib.mpas,108 :: 		Err := SetPoint - InputValue;
	MOVF        FARG_PID_Calculate_InputValue+0, 0 
	MOVWF       R4 
	MOVF        FARG_PID_Calculate_InputValue+1, 0 
	MOVWF       R5 
	MOVF        FARG_PID_Calculate_InputValue+2, 0 
	MOVWF       R6 
	MOVF        FARG_PID_Calculate_InputValue+3, 0 
	MOVWF       R7 
	MOVF        FARG_PID_Calculate_Setpoint+0, 0 
	MOVWF       R0 
	MOVF        FARG_PID_Calculate_Setpoint+1, 0 
	MOVWF       R1 
	MOVF        FARG_PID_Calculate_Setpoint+2, 0 
	MOVWF       R2 
	MOVF        FARG_PID_Calculate_Setpoint+3, 0 
	MOVWF       R3 
	CALL        _Sub_32x32_FP+0, 0
	MOVF        R0, 0 
	MOVWF       PID_Calculate_Err+0 
	MOVF        R1, 0 
	MOVWF       PID_Calculate_Err+1 
	MOVF        R2, 0 
	MOVWF       PID_Calculate_Err+2 
	MOVF        R3, 0 
	MOVWF       PID_Calculate_Err+3 
;PID_Lib.mpas,111 :: 		ErrValue  := Err * PID_Kp;
	MOVFF       FARG_PID_Calculate_Controller+0, FSR0L
	MOVFF       FARG_PID_Calculate_Controller+1, FSR0H
	MOVF        POSTINC0+0, 0 
	MOVWF       R4 
	MOVF        POSTINC0+0, 0 
	MOVWF       R5 
	MOVF        POSTINC0+0, 0 
	MOVWF       R6 
	MOVF        POSTINC0+0, 0 
	MOVWF       R7 
	CALL        _Mul_32x32_FP+0, 0
	MOVF        R0, 0 
	MOVWF       PID_Calculate_ErrValue+0 
	MOVF        R1, 0 
	MOVWF       PID_Calculate_ErrValue+1 
	MOVF        R2, 0 
	MOVWF       PID_Calculate_ErrValue+2 
	MOVF        R3, 0 
	MOVWF       PID_Calculate_ErrValue+3 
;PID_Lib.mpas,114 :: 		if PID_Int_Improvement then if Sign(Err) <> Sign(PID_Integrated) then PID_Integrated := 0;
	MOVLW       29
	ADDWF       FARG_PID_Calculate_Controller+0, 0 
	MOVWF       FSR0L 
	MOVLW       0
	ADDWFC      FARG_PID_Calculate_Controller+1, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L__PID_Calculate16
	MOVF        PID_Calculate_Err+0, 0 
	MOVWF       FARG_Sign_Value+0 
	MOVF        PID_Calculate_Err+1, 0 
	MOVWF       FARG_Sign_Value+1 
	MOVF        PID_Calculate_Err+2, 0 
	MOVWF       FARG_Sign_Value+2 
	MOVF        PID_Calculate_Err+3, 0 
	MOVWF       FARG_Sign_Value+3 
	CALL        PID_Lib_Sign+0, 0
	MOVF        R0, 0 
	MOVWF       FLOC__PID_Calculate+0 
	MOVLW       12
	ADDWF       FARG_PID_Calculate_Controller+0, 0 
	MOVWF       FSR0L 
	MOVLW       0
	ADDWFC      FARG_PID_Calculate_Controller+1, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       FARG_Sign_Value+0 
	MOVF        POSTINC0+0, 0 
	MOVWF       FARG_Sign_Value+1 
	MOVF        POSTINC0+0, 0 
	MOVWF       FARG_Sign_Value+2 
	MOVF        POSTINC0+0, 0 
	MOVWF       FARG_Sign_Value+3 
	CALL        PID_Lib_Sign+0, 0
	MOVF        FLOC__PID_Calculate+0, 0 
	XORWF       R0, 0 
	BTFSC       STATUS+0, 2 
	GOTO        L__PID_Calculate19
	MOVLW       12
	ADDWF       FARG_PID_Calculate_Controller+0, 0 
	MOVWF       FSR1L 
	MOVLW       0
	ADDWFC      FARG_PID_Calculate_Controller+1, 0 
	MOVWF       FSR1H 
	CLRF        POSTINC1+0 
	CLRF        POSTINC1+0 
	CLRF        POSTINC1+0 
	CLRF        POSTINC1+0 
L__PID_Calculate19:
L__PID_Calculate16:
;PID_Lib.mpas,117 :: 		PID_Integrated := PID_Integrated + (Err * PID_Ki);
	MOVLW       12
	ADDWF       FARG_PID_Calculate_Controller+0, 0 
	MOVWF       FLOC__PID_Calculate+2 
	MOVLW       0
	ADDWFC      FARG_PID_Calculate_Controller+1, 0 
	MOVWF       FLOC__PID_Calculate+3 
	MOVLW       12
	ADDWF       FARG_PID_Calculate_Controller+0, 0 
	MOVWF       FLOC__PID_Calculate+0 
	MOVLW       0
	ADDWFC      FARG_PID_Calculate_Controller+1, 0 
	MOVWF       FLOC__PID_Calculate+1 
	MOVLW       4
	ADDWF       FARG_PID_Calculate_Controller+0, 0 
	MOVWF       FSR2L 
	MOVLW       0
	ADDWFC      FARG_PID_Calculate_Controller+1, 0 
	MOVWF       FSR2H 
	MOVF        POSTINC2+0, 0 
	MOVWF       R0 
	MOVF        POSTINC2+0, 0 
	MOVWF       R1 
	MOVF        POSTINC2+0, 0 
	MOVWF       R2 
	MOVF        POSTINC2+0, 0 
	MOVWF       R3 
	MOVF        PID_Calculate_Err+0, 0 
	MOVWF       R4 
	MOVF        PID_Calculate_Err+1, 0 
	MOVWF       R5 
	MOVF        PID_Calculate_Err+2, 0 
	MOVWF       R6 
	MOVF        PID_Calculate_Err+3, 0 
	MOVWF       R7 
	CALL        _Mul_32x32_FP+0, 0
	MOVFF       FLOC__PID_Calculate+0, FSR0L
	MOVFF       FLOC__PID_Calculate+1, FSR0H
	MOVF        POSTINC0+0, 0 
	MOVWF       R4 
	MOVF        POSTINC0+0, 0 
	MOVWF       R5 
	MOVF        POSTINC0+0, 0 
	MOVWF       R6 
	MOVF        POSTINC0+0, 0 
	MOVWF       R7 
	CALL        _Add_32x32_FP+0, 0
	MOVFF       FLOC__PID_Calculate+2, FSR1L
	MOVFF       FLOC__PID_Calculate+3, FSR1H
	MOVF        R0, 0 
	MOVWF       POSTINC1+0 
	MOVF        R1, 0 
	MOVWF       POSTINC1+0 
	MOVF        R2, 0 
	MOVWF       POSTINC1+0 
	MOVF        R3, 0 
	MOVWF       POSTINC1+0 
;PID_Lib.mpas,119 :: 		Limit(PID_Integrated, PID_MinOutput, PID_MaxOutput);
	MOVLW       12
	ADDWF       FARG_PID_Calculate_Controller+0, 0 
	MOVWF       FARG_Limit_Value+0 
	MOVLW       0
	ADDWFC      FARG_PID_Calculate_Controller+1, 0 
	MOVWF       FARG_Limit_Value+1 
	MOVLW       20
	ADDWF       FARG_PID_Calculate_Controller+0, 0 
	MOVWF       FSR0L 
	MOVLW       0
	ADDWFC      FARG_PID_Calculate_Controller+1, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       FARG_Limit_MinOutput+0 
	MOVF        POSTINC0+0, 0 
	MOVWF       FARG_Limit_MinOutput+1 
	MOVF        POSTINC0+0, 0 
	MOVWF       FARG_Limit_MinOutput+2 
	MOVF        POSTINC0+0, 0 
	MOVWF       FARG_Limit_MinOutput+3 
	MOVLW       24
	ADDWF       FARG_PID_Calculate_Controller+0, 0 
	MOVWF       FSR0L 
	MOVLW       0
	ADDWFC      FARG_PID_Calculate_Controller+1, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       FARG_Limit_MaxOutput+0 
	MOVF        POSTINC0+0, 0 
	MOVWF       FARG_Limit_MaxOutput+1 
	MOVF        POSTINC0+0, 0 
	MOVWF       FARG_Limit_MaxOutput+2 
	MOVF        POSTINC0+0, 0 
	MOVWF       FARG_Limit_MaxOutput+3 
	CALL        PID_Lib_Limit+0, 0
;PID_Lib.mpas,122 :: 		if PID_First_Time then
	MOVLW       28
	ADDWF       FARG_PID_Calculate_Controller+0, 0 
	MOVWF       FSR0L 
	MOVLW       0
	ADDWFC      FARG_PID_Calculate_Controller+1, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L__PID_Calculate22
;PID_Lib.mpas,124 :: 		PID_First_Time := false;
	MOVLW       28
	ADDWF       FARG_PID_Calculate_Controller+0, 0 
	MOVWF       FSR1L 
	MOVLW       0
	ADDWFC      FARG_PID_Calculate_Controller+1, 0 
	MOVWF       FSR1H 
	CLRF        POSTINC1+0 
;PID_Lib.mpas,125 :: 		PID_Prev_Input := InputValue;
	MOVLW       16
	ADDWF       FARG_PID_Calculate_Controller+0, 0 
	MOVWF       FSR1L 
	MOVLW       0
	ADDWFC      FARG_PID_Calculate_Controller+1, 0 
	MOVWF       FSR1H 
	MOVF        FARG_PID_Calculate_InputValue+0, 0 
	MOVWF       POSTINC1+0 
	MOVF        FARG_PID_Calculate_InputValue+1, 0 
	MOVWF       POSTINC1+0 
	MOVF        FARG_PID_Calculate_InputValue+2, 0 
	MOVWF       POSTINC1+0 
	MOVF        FARG_PID_Calculate_InputValue+3, 0 
	MOVWF       POSTINC1+0 
;PID_Lib.mpas,126 :: 		end;
L__PID_Calculate22:
;PID_Lib.mpas,127 :: 		DiffValue := (InputValue - PID_Prev_Input) * PID_Kd;
	MOVLW       16
	ADDWF       FARG_PID_Calculate_Controller+0, 0 
	MOVWF       FSR2L 
	MOVLW       0
	ADDWFC      FARG_PID_Calculate_Controller+1, 0 
	MOVWF       FSR2H 
	MOVF        POSTINC2+0, 0 
	MOVWF       R4 
	MOVF        POSTINC2+0, 0 
	MOVWF       R5 
	MOVF        POSTINC2+0, 0 
	MOVWF       R6 
	MOVF        POSTINC2+0, 0 
	MOVWF       R7 
	MOVF        FARG_PID_Calculate_InputValue+0, 0 
	MOVWF       R0 
	MOVF        FARG_PID_Calculate_InputValue+1, 0 
	MOVWF       R1 
	MOVF        FARG_PID_Calculate_InputValue+2, 0 
	MOVWF       R2 
	MOVF        FARG_PID_Calculate_InputValue+3, 0 
	MOVWF       R3 
	CALL        _Sub_32x32_FP+0, 0
	MOVLW       8
	ADDWF       FARG_PID_Calculate_Controller+0, 0 
	MOVWF       FSR2L 
	MOVLW       0
	ADDWFC      FARG_PID_Calculate_Controller+1, 0 
	MOVWF       FSR2H 
	MOVF        POSTINC2+0, 0 
	MOVWF       R4 
	MOVF        POSTINC2+0, 0 
	MOVWF       R5 
	MOVF        POSTINC2+0, 0 
	MOVWF       R6 
	MOVF        POSTINC2+0, 0 
	MOVWF       R7 
	CALL        _Mul_32x32_FP+0, 0
	MOVF        R0, 0 
	MOVWF       PID_Calculate_DiffValue+0 
	MOVF        R1, 0 
	MOVWF       PID_Calculate_DiffValue+1 
	MOVF        R2, 0 
	MOVWF       PID_Calculate_DiffValue+2 
	MOVF        R3, 0 
	MOVWF       PID_Calculate_DiffValue+3 
;PID_Lib.mpas,128 :: 		PID_Prev_Input := InputValue;
	MOVLW       16
	ADDWF       FARG_PID_Calculate_Controller+0, 0 
	MOVWF       FSR1L 
	MOVLW       0
	ADDWFC      FARG_PID_Calculate_Controller+1, 0 
	MOVWF       FSR1H 
	MOVF        FARG_PID_Calculate_InputValue+0, 0 
	MOVWF       POSTINC1+0 
	MOVF        FARG_PID_Calculate_InputValue+1, 0 
	MOVWF       POSTINC1+0 
	MOVF        FARG_PID_Calculate_InputValue+2, 0 
	MOVWF       POSTINC1+0 
	MOVF        FARG_PID_Calculate_InputValue+3, 0 
	MOVWF       POSTINC1+0 
;PID_Lib.mpas,131 :: 		Result := ErrValue + PID_Integrated - DiffValue; // mind the minus sign!!!
	MOVLW       12
	ADDWF       FARG_PID_Calculate_Controller+0, 0 
	MOVWF       FSR2L 
	MOVLW       0
	ADDWFC      FARG_PID_Calculate_Controller+1, 0 
	MOVWF       FSR2H 
	MOVF        PID_Calculate_ErrValue+0, 0 
	MOVWF       R0 
	MOVF        PID_Calculate_ErrValue+1, 0 
	MOVWF       R1 
	MOVF        PID_Calculate_ErrValue+2, 0 
	MOVWF       R2 
	MOVF        PID_Calculate_ErrValue+3, 0 
	MOVWF       R3 
	MOVF        POSTINC2+0, 0 
	MOVWF       R4 
	MOVF        POSTINC2+0, 0 
	MOVWF       R5 
	MOVF        POSTINC2+0, 0 
	MOVWF       R6 
	MOVF        POSTINC2+0, 0 
	MOVWF       R7 
	CALL        _Add_32x32_FP+0, 0
	MOVF        PID_Calculate_DiffValue+0, 0 
	MOVWF       R4 
	MOVF        PID_Calculate_DiffValue+1, 0 
	MOVWF       R5 
	MOVF        PID_Calculate_DiffValue+2, 0 
	MOVWF       R6 
	MOVF        PID_Calculate_DiffValue+3, 0 
	MOVWF       R7 
	CALL        _Sub_32x32_FP+0, 0
	MOVF        R0, 0 
	MOVWF       PID_Calculate_local_result+0 
	MOVF        R1, 0 
	MOVWF       PID_Calculate_local_result+1 
	MOVF        R2, 0 
	MOVWF       PID_Calculate_local_result+2 
	MOVF        R3, 0 
	MOVWF       PID_Calculate_local_result+3 
;PID_Lib.mpas,133 :: 		Limit(Result, PID_MinOutput, PID_MaxOutput);
	MOVLW       PID_Calculate_local_result+0
	MOVWF       FARG_Limit_Value+0 
	MOVLW       hi_addr(PID_Calculate_local_result+0)
	MOVWF       FARG_Limit_Value+1 
	MOVLW       20
	ADDWF       FARG_PID_Calculate_Controller+0, 0 
	MOVWF       FSR0L 
	MOVLW       0
	ADDWFC      FARG_PID_Calculate_Controller+1, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       FARG_Limit_MinOutput+0 
	MOVF        POSTINC0+0, 0 
	MOVWF       FARG_Limit_MinOutput+1 
	MOVF        POSTINC0+0, 0 
	MOVWF       FARG_Limit_MinOutput+2 
	MOVF        POSTINC0+0, 0 
	MOVWF       FARG_Limit_MinOutput+3 
	MOVLW       24
	ADDWF       FARG_PID_Calculate_Controller+0, 0 
	MOVWF       FSR0L 
	MOVLW       0
	ADDWFC      FARG_PID_Calculate_Controller+1, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       FARG_Limit_MaxOutput+0 
	MOVF        POSTINC0+0, 0 
	MOVWF       FARG_Limit_MaxOutput+1 
	MOVF        POSTINC0+0, 0 
	MOVWF       FARG_Limit_MaxOutput+2 
	MOVF        POSTINC0+0, 0 
	MOVWF       FARG_Limit_MaxOutput+3 
	CALL        PID_Lib_Limit+0, 0
;PID_Lib.mpas,136 :: 		end;
	MOVF        PID_Calculate_local_result+0, 0 
	MOVWF       R0 
	MOVF        PID_Calculate_local_result+1, 0 
	MOVWF       R1 
	MOVF        PID_Calculate_local_result+2, 0 
	MOVWF       R2 
	MOVF        PID_Calculate_local_result+3, 0 
	MOVWF       R3 
L_end_PID_Calculate:
	RETURN      0
; end of _PID_Calculate
